<?









function dbfile_exists($name, $folder_id, $id = 0) {
 
 $folderinfo = get_folderinfo($folder_id);
 $pub_dir = $folderinfo["pub_dir"];
 $node_id = $folderinfo["node_id"];

 
 $a_name = sqlslashes($name);

 
 if ($id) {
 $fileinfo = get_fileinfo($id);
 
 $channelset_id = $fileinfo["channelset_id"];
 }

 
 $sql = "SELECT contentfile.id, contentfile.name FROM contentfile, folder WHERE 
contentfile.folder_id = folder.id AND folder.node_id = ".sqlf_tl_num($node_id)." AND folder.pub_dir = '".sqlslashes($pub_dir)."' AND contentfile.name = '".sqlf_escaped($a_name)."'";
 if ($id) {
 $sql .= " AND contentfile.id != ".sqlf_tl_num($id);
 }
 if ($channelset_id) {
 
 $sql .= " AND contentfile.channelset_id != ".sqlf_tl_num($channelset_id);
 }

 $rs = query($sql);

 if ($rs["num"] > 0) {
 return $rs["arr"][0]["id"];
 } else {
 return false;
 }
}








function dbfile_size($file_id) {
 global $ERROR;
 $sql = "SELECT filesize FROM contentfile WHERE id = ".sqlf_tl_num($file_id);
 $rs = query($sql);

 if ($rs["num"] == 0) {
 $ERROR = "no file with id $file_id";
 return false;
 } elseif ($rs["num"] > 1) {
 $ERROR = "too many files found<br>";
 return false;
 } else {
 return $rs["arr"][0]["filesize"];
 }
}

function dbfile_getid($name, $folder_id) {
 $sql = "SELECT pub_dir, node_id FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $pub_dir = $rs["arr"][0]["pub_dir"];
 $node_id = $rs["arr"][0]["node_id"];
 $a_name = sqlslashes($name);
 $sql = "SELECT contentfile.id, contentfile.name FROM contentfile, folder WHERE 
contentfile.folder_id = folder.id AND folder.node_id = ".sqlf_tl_num($node_id)." AND folder.pub_dir = '".sqlslashes($pub_dir)."' AND contentfile.name = '".sqlf_escaped($name)."'";
 $rs = query($sql);
$id = $rs["arr"][0]["id"];
if ($id) return $id;
else return false;
}

function dbfile_getinfo($name, $folder_id) {
 global $SQLAS;
 $sql = "SELECT contentfile.id, contentfile.name, contentfile.description, contentfile.filesize, contentfile.md5 FROM contentfile, folder, folder $SQLAS f2 WHERE 
contentfile.folder_id = folder.id AND folder.node_id = f2.node_id AND folder.pub_dir = f2.pub_dir AND contentfile.name = '".sqlf_escaped($name)."' AND f2.id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 return $rs["arr"][0];
}






function cmd_file_create($name,$folder_id,$description,$orig_name="",$dryrun=false, $force_online = false) {
 global $TIME,$USER_ID,$T_FILE,$DIC,$W_CREATE, $ERROR, $T_FOLDER, $FEATURE, $NODE_ID;

 
 if ($name === false || $name === "") halt(7, "cmd_file_create: No name ($name)");
 if (!isset($folder_id) || $folder_id == "") halt(7, "cmd_file_create: No folder_id isset or \"\" ($folder_id)");

 
 $folder = new CNFolderObject($folder_id);
 $folder_id = $folder->getMasterId();

 if (!perm($USER_ID,$T_FOLDER,$folder_id,12,null,$T_FILE,11)) {
 $ERROR = i18n('cn_cmd_file_create_permission_denied'); 
 return false;
 }

 
 if ($orig_name && $orig_name != $name) {
 ereg("\.([a-zA-Z0-9]*)$", $orig_name, $orig);
 ereg("\.([a-zA-Z0-9]*)$", $name, $new);
 if ($orig[1] && $new[1] != $orig[1]) {
 
 if (!$new[1]) {
 $name = $name.".".$orig[1];
 } else {
 $ERROR = i18n('file_extensions_may_not');
 return false;
 }
 }
 }
 if (dbfile_exists($name, $folder_id)) {
 $ERROR = i18n('a_file_with_this_name');
 return false;
 }

 if ($dryrun) {
 return true;
 }

 
 $folderinfo = get_folderinfo($folder_id);
 
 $node_id = $NODE_ID;
 
 
 if (!isset($NODE_ID) && isset($folder_id)) {
 $folderinfo = get_folderinfo($folder_id);
 $node_id = $folderinfo["node_id"];
 }
 
 $nodeinfo = get_nodeinfo($node_id);
 
 
 if ( $FEATURE["multichannelling"] && ($folderinfo["node_id"] != $NODE_ID) && ($nodeinfo["master_id"] > 0) ) {
 $channel_id = $NODE_ID;
 } else {
 $channel_id = 0;
 }
 
 
 if (! isset($channel_id) ) {
 $channel_id = 0;
 }

 
 $name = sqlslashes($name);
 $description = sqlslashes($description);

 
 $channelsetId = createChannelsetId();

 $sql = "INSERT INTO contentfile (name,folder_id,description,creator,cdate,editor,edate, channel_id, force_online, channelset_id) 
VALUES ('".sqlf_escaped($name)."',".sqlf_tl_num($folder_id).",'".sqlf_escaped($description)."',".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).", ".sqlf_tl_num($channel_id).", ".($force_online ? 1 : 0).",".sqlf_tl_num($channelsetId).")";
 $rs = query($sql);
 $file_id = $rs["iid"];
 if($FEATURE["contentfile_data_to_db"]) {
 
 $sql = "INSERT INTO contentfiledata (contentfile_id, binarycontent) VALUES (".sqlf_tl_num($file_id).", '')";
 query($sql);
 }
 
 
 logcmd($W_CREATE, $T_FILE, $file_id , $folder_id, "cmd_file_create");
 triggerEvent( $T_FILE, $file_id, EVENT_CREATE, new EventObject() );
 if ($FEATURE["cn_notification"]) cn_notify($file_id,$T_FILE,$name,$folder_id,$T_FOLDER);

 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_FOLDER, $folder_id);

 return $file_id;
}


function cmd_file_data($file_id,$data,$size,$type) {
 global $TIME,$USER_ID,$DIC,$W_EDIT,$T_FILE, $ERROR, $T_FOLDER, $FILEPATH, $MODULE, $FEATURE;

 
 if (!$file_id) halt(7,"cmd_file_data: no file_id to update.");

 
 $changed = array();







 $sql = "SELECT * FROM contentfile WHERE id = ".sqlf_tl_num($file_id);
 $rs = query($sql);

 savefile($file_id, $data);
 $filetype = strtolower($type);
 $filetype = sqlslashes($filetype);
 if ($USER_ID != 1) $sqlpart = ", editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME);
 else $sqlpart = "";

 $sub_type = substr($type,strpos($type,"/")+1);
 $type = substr($type,0,strpos($type,"/"));

 
 if($FEATURE["contentfile_data_to_db"]) {
 $md5 = md5($data);
 } else {
 $md5 = md5_file("$FILEPATH/$MODULE/dbfiles/$file_id.bin");
 }
 
 if ($sub_type == "pdf")
 {
 $type = "application";
 $filetype = "application/pdf";
 } 
 
 
 if ($type == "image") {
 cmd_filecache_clear($file_id);
 $img = new img_resize();
 if($FEATURE["contentfile_data_to_db"]) {
 $img->setId($file_id);
 } else {
 $img->setFile( "$FILEPATH/$MODULE/dbfiles/$file_id.bin" );
 }
 $img->clearCache();
 $img->getImageType();
 $sqlpart = ", sizex = ".((int)$img->imgwidth).", sizey = ".((int)$img->imgheight). ", dpix=".((int)$img->imgdpix).",dpiy=".((int)$img->imgdpiy);
 if ($rs["arr"][0]["sizex"] != $img->imgwidth) {
 $changed[] = "sizex";
 }
 if ($rs["arr"][0]["sizey"] != $img->imgheight) {
 $changed[] = "sizey";
 }
 if ($rs["arr"][0]["dpix"] != $img->imgdpix) {
 $changed[] = "dpix";
 }
 if ($rs["arr"][0]["dpiy"] != $img->imgdpiy) {
 $changed[] = "dpiy";
 }
 }
 
 $sql = "UPDATE contentfile SET filesize=".sqlf_tl_num($size).", md5='".sqlf_escaped($md5)."', edate=".sqlf_tl_num($TIME).", editor=".sqlf_tl_num($USER_ID).",filetype='".sqlf_escaped($filetype)."'$sqlpart WHERE id = ".sqlf_tl_num($file_id);

 query($sql);

 
 logcmd($W_EDIT, $T_FILE, $file_id , 0, "cmd_file_data");

 $changed[] = "editor";
 $changed[] = "edate";
 $changed[] = "filetype";
 $changed[] = "binarycontent";
 triggerEvent(CT_FILE, $file_id, EVENT_UPDATE, new EventObject(null, $changed) );

 return $file_id;
}














function cmd_file_update($file_id,$folder_id,$name,$description, $f_userfile_name = false, $f_userfile_type = false, $forceextensionrename = false, $dryrun = false, $force_online = false) {
 global $TIME,$USER_ID,$DIC,$W_EDIT,$T_FILE, $ERROR, $T_FOLDER, $FILEPATH, $MODULE, $FEATURE, $ERROR_DUPLICATE;

 
 if (!$file_id) halt(7,"cmd_file_update: no file_id to update.");

 if (!perm($USER_ID,$T_FOLDER,$folder_id,13,NULL,$T_FILE,12)) {

 $ERROR = i18n('832.you_have_no_permission_to');
 return false;
 }

 
 $sql = "SELECT * FROM contentfile WHERE id = ".sqlf_tl_num($file_id);
 $rs = query($sql);
 if ($f_userfile_type) {
 $type = $f_userfile_type;
 } else {
 $type = $rs["arr"][0]["filetype"];
 }

 
 $orig_name = sqlslashes($rs["arr"][0]["name"]);
 $orig_description = sqlslashes($rs["arr"][0]["description"]);
 $orig_filetype = sqlslashes($rs["arr"][0]["filetype"]);
 $orig_force_online = $rs["arr"][0]["force_online"];
 
 
 ereg("\.([a-zA-Z0-9]*)$",$rs["arr"][0]["name"], $orig);
 ereg("\.([a-zA-Z0-9]*)$",$name, $new);

 if (!$forceextensionrename && !$f_userfile_name && $orig[1] && strtolower($new[1]) != strtolower($orig[1])) {
 $ERROR = i18n('file_extensions_may_not');
 return false;
 }
 
 





 if (strcmp($f_userfile_name,"") != 0) {
 $pregFilenameExtension = "/(.*)\.(\w{2,4})$/";
 preg_match($pregFilenameExtension,$rs["arr"][0]["name"],$matchOrig);
 preg_match($pregFilenameExtension,$f_userfile_name,$matchNew);
 
 if ($name == $rs["arr"][0]["name"] && strcmp(strtolower($matchOrig[2]),strtolower($matchNew[2])) == 0) {
 $name = $rs["arr"][0]["name"];
 
 } elseif ($name == $rs["arr"][0]["name"] && strcmp(strtolower($matchOrig[2]),strtolower($matchNew[2])) != 0) {
 $name = $matchOrig[1] . '.' . $matchNew[2];
 }
 }
 
 



 if ($f_userfile_name && ($rs["arr"][0]["name"] != $name)) {
 preg_match("/\.\w{2,4}$/",$f_userfile_name,$matchUserfileName);
 preg_match("/\.\w{2,4}$/",$name,$matchName);
 if (strcmp($matchName[0],$matchUserfileName[0]) != 0) {
 $ERROR = i18n('file extensions of the uploaded file and the desired filename do not match');
 return false;
 }
 }
 
 
 if ($rs["arr"][0]["name"] != $name) {
 if (dbfile_exists($name, $folder_id, $file_id)) {
 $ERROR = i18n('a_file_with_this_name');
 $ERROR_DUPLICATE = true;
 return false;
 }
 }

 if ($dryrun) {
 return true;
 }

 $changed = array();
 
 $name = sqlslashes($name);
 $description = sqlslashes($description);

 $type = substr($type,0,strpos($type,"/"));
 if ($type == "image") {
 $img = new img_resize();
 if($FEATURE["contentfile_data_to_db"]) {
 $img->setId($file_id);
 } else {
 $img->setFile( "$FILEPATH/$MODULE/dbfiles/$file_id.bin" );
 }
 $img->clearCache();
 
 $img->getImageType();
 $sqlpart = ", sizex = ".((int)$img->imgwidth).", sizey = ".((int)$img->imgheight). ", dpix=".((int)$img->imgdpix).",dpiy=".((int)$img->imgdpiy);
 if ($rs["arr"][0]["sizex"] != $img->imgwidth) {
 $changed[] = "sizex";
 }
 if ($rs["arr"][0]["sizey"] != $img->imgheight) {
 $changed[] = "sizey";
 }
 if ($rs["arr"][0]["dpix"] != $img->imgdpix) {
 $changed[] = "dpix";
 }
 if ($rs["arr"][0]["dpiy"] != $img->imgdpiy) {
 $changed[] = "dpiy";
 }
 } else {
 
 $sqlpart = ", sizex=0, sizey=0, dpix=0, dpiy=0";
 }

 
 if ($name != $orig_name) {
 $changed[] = "name";
 }
 if ($description != $orig_description) {
 $changed[] = "description";
 }

 if ($force_online != $orig_force_online) {
 $sqlpart .= ", force_online = ".($force_online ? 1 : 0);
 $changed[] = "force_online";
 }
 
 
 if ($f_userfile_type) {
 $sqlpart .= ", filetype='".sqlf_escaped($f_userfile_type)."'";
 if ($orig_filetype != $f_userfile_type) {
 $changed[] = "filetype";
 }

 }

 
 if (count($changed) == 0) {
 return $file_id;
 }

 $changed[] = "editor";
 $changed[] = "edate";
 $sql = "UPDATE contentfile 
          SET name = '".sqlf_escaped($name)."', editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", description = '".sqlf_escaped($description)."' $sqlpart
          WHERE id = ".sqlf_tl_num($file_id);
 query($sql);

 
 logcmd($W_EDIT, $T_FILE, $file_id , 0, "cmd_file_update");
 triggerEvent( $T_FILE, $file_id, EVENT_UPDATE, new EventObject(array("name"=>$name, "editor"=>$USER_ID, "description"=>$description), $changed) );

 return $file_id;
}








function cmd_file_del_wf($id, $checkperms = true) {
 global $USER_ID,$TIME,$DIC,$W_DEL,$T_FILE, $T_FOLDER;
 
 
 if (!$id) halt(0,"cmd_file_del: No file_id to delete");

 
 if ( !is_array($id) ) {
 $id = array( $id=>true );
 }

 $del_ids = array();

 
 while (list($key,$val) = each($id)) {
 $sql = "SELECT folder_id FROM contentfile WHERE id = ".sqlf_tl_num($key);
 $rs = query($sql,1);
 $folder_id = $rs["arr"][0]["folder_id"];

 
 if ($checkperms && !perm($USER_ID,$T_FOLDER,$folder_id,14,null,$T_FILE,13)) {
 $ERROR = i18n('832.you_have_no_permission_to');
 } else {
 
 if (trigger_event("onfiledelete", array("file_id" => $key, "folder_id" => $folder_id))) {
 continue;
 } else {
 $del_ids[] = $key;
 }
 }
 }

 return $del_ids;
}






function cmd_file_del($id) {
 global $ERROR, $JAVAPARSER_RETURN, $T_FILE;

 
 if (!$id) halt(0,"cmd_file_del: No file_id to delete");

 
 $del_ids = cmd_file_del_wf($id);

 $error = false;
 if (!empty($del_ids)) {
 
 $javaParser =& CodeParser::getJavaParser();
 $ERROR = $javaParser->deleteObject($T_FILE, $del_ids);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 }

 return $error;
}






function file_is_inherited($ids) {
 global $FEATURE, $NODE_ID;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 $nodeinfo = get_nodeinfo($NODE_ID);
 
 if ($nodeinfo["master_id"] > 0) {
 $sql = "SELECT count(*) c FROM contentfile WHERE id IN (".sqlf_value_list(implode(",", array_keys($ids))).") AND channel_id != ".sqlf_tl_num($NODE_ID);
 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 } else {
 
 return false;
 }
 } else {
 return false;
 }
}






function file_has_localized_copy($ids) {
 global $FEATURE;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }
 if (is_array($ids) && count($ids) > 0) {
 
 $sql = "SELECT count(*) c FROM contentfile WHERE channelset_id IN (SELECT channelset_id FROM contentfile WHERE id IN (".
 sqlf_value_list(implode(",", array_keys($ids))).") AND is_master = 1) AND is_master = 0";
 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 } else {
 return false;
 }
}









function cmd_file_move($source, $target, $target_node_id = 0) {
 global $USER_ID,$TIME,$DIC,$W_MOVE,$T_FOLDER, $ERROR, $T_FILE, $FEATURE, $T_DOMAIN_CHANNEL;

 if (!$source) halt(0,"cmd_file_move: No source to move");
 if (!$target) halt(0,"cmd_file_move: No target to move");

 
 if (!perm($USER_ID,$T_FOLDER,$target,12,null,$T_FILE,11)) {
 $ERROR = i18n('you_have_no_permission_to');
 return true;
 }

 $folder = new CNFolderObject($target);
 if (!$target_node_id) {
 $folderinfo = get_folderinfo($target);
 $target_node_id = $folderinfo["channel_id"];
 }
 $target = $folder->getMasterId();

 
 $folderinfo = get_folderinfo($target);

 $node_id = $folderinfo["node_id"];
 $pub_dir = $folderinfo["pub_dir"];

 if ($target_node_id) {
 $target_nodeinfo = get_nodeinfo($target_node_id);
 }

 
 $error = false;
 if ( !is_array( $source ) ) $source = array( $source=>"" );

 
 $source = array_keys($source);

 
 if ($FEATURE["multichannelling"]) {
 
 $sql = "SELECT id FROM contentfile WHERE id IN (".sqlf_value_list(implode(",", $source)).") AND is_master = 1";
 $rs = query($sql);
 $cleansource = array();
 foreach ($rs["arr"] as $row) {
 $cleansource[$row["id"]] = true;
 }
 
 $source = array_keys($cleansource);
 
 
 if (count($source) == 0) {
 return false;
 }
 }

 
 $sql = "SELECT DISTINCT folder_id id FROM contentfile WHERE id IN (".sqlf_value_list(implode(",", $source)).")";
 $rs = query($sql);
 $source_folders = $rs["arr"];
 foreach ($source as $id) {
 if (!perm_can_move_file($id)) {
 $ERROR = i18n('could_not_move_all');
 return true;
 }
 }

 
 $sql = "SELECT id, name, folder_id, filetype, channelset_id, channel_id, is_master FROM contentfile WHERE id IN (". sqlf_value_list(implode(",", $source)) .")";
 $rs = query($sql);
 $files = $rs["arr"];

 
 if ($FEATURE["multichannelling"]) {
 $sql = "SELECT id, name, folder_id, filetype, channelset_id, channel_id, is_master FROM contentfile WHERE is_master = 0 AND channelset_id IN (SELECT channelset_id FROM contentfile WHERE id IN (" . implode(",", sqlf_tl_num_array($source)) . "))";
 $rs = query($sql);
 $files = array_merge($files, $rs["arr"]);
 }

 
 if ( !file_is_unique_db_column_ci($files, "name")) {
 $ERROR = i18n('Unable to copy files due to conflicting file names.');
 return true;
 }

 
 foreach ($files as $file) {
 if (dbfile_exists($file["name"], $target, $file["id"])) {
 $ERROR = i18n('Unable to copy files due to conflicting file names.');
 return true;
 }
 }

 $javaParser =& CodeParser::getJavaParser();

 
 foreach ($files as $file) {
 $folderinfo = get_folderinfo($file["folder_id"]);
 
 if (!$file["is_master"]) {
 if ($folderinfo["node_id"] != $node_id) {
 $ERROR = $javaParser->deleteObject(ereg('image', $file["filetype"]) ? T_IMAGE : CT_FILE, $file["id"]);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 continue;
 }
 }

 $sql = "UPDATE contentfile SET folder_id = ".sqlf_tl_num($target).", edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID);

 
 if ($file["is_master"]) {
 $sql .= ", channel_id = ";
 if ($target_nodeinfo && $target_nodeinfo["master_id"]) {
 $sql .= sqlf_tl_num($target_nodeinfo["id"]);
 } else {
 $sql .= "0";
 }
 }

 $sql .= " WHERE id = ".sqlf_tl_num($file["id"]);
 query($sql);

 
 logcmd($W_MOVE, $T_FILE, $file["id"], $target, "cmd_file_move");
 triggerEvent( $T_FILE, $file["id"], EVENT_MOVE, new EventObject( array("toId"=>$target), array($folderinfo["node_id"]) ) );

 }

 
 foreach($source_folders as $row) {
 triggerEvent(T_FOLDER, $row["id"], EVENT_UPDATE, new EventObject(null, array("files", "images")));
 }

 if (count($files) > 0) {
 
 triggerEvent(T_FOLDER, $target, EVENT_UPDATE, new EventObject(null, array("files", "images")) );
 }

 
 return false;
}

function cmd_filecache_clear($id) {
global $FILEPATH,$MODULE;
$imageResizer = new img_resize();
$imageResizer->warn_on_error = true;
if($FEATURE["contentfile_data_to_db"]) {
 $imageResizer->setId($file_id);
} else {
 $imageResizer->setFile( "$FILEPATH/$MODULE/dbfiles/$file_id.bin" );
}
 
$imageResizer->clearCache();
}












function suggest_new_filename($oldname, $folder_id, $file_id = false) {
 
 if (eregi("^(.*)_([0-9]*)\\.([^\\.]*)$", $oldname, $regs)) {
 $filename = $regs[1];
 $number = $regs[2];
 if (!$number) {
 $number = 0;
 }
 $extension = ".".$regs[3];
 } else if (eregi("^(.*)\\.([^\\.]*)$", $oldname, $regs)) {
 $filename = $regs[1];
 $number = 0;
 $extension = ".".$regs[2];
 } else {
 $filename = $oldname;
 $number = 0;
 $extension = "";
 }

 
 $folder = get_folderinfo($folder_id);

 $pub_dir = $folder["pub_dir"];
 $node_id = $folder["node_id"];

 
 $filepattern = $filename."%".$extension;
 $sql = "SELECT contentfile.id, contentfile.name FROM contentfile, folder WHERE contentfile.folder_id = folder.id AND folder.node_id = ".sqlf_tl_num($node_id)." AND folder.pub_dir = '".sqlslashes($pub_dir)."' AND contentfile.name LIKE '".sqlslashes($filepattern)."'";
 if ($file_id) {
 $sql .= " AND contentfile.id != ".sqlf_tl_num($file_id);
 }
 $rs = query($sql);

 $filename_found = true;
 
 $new_filename = $oldname;
 for ($i = 0; $i < sizeof($rs["arr"]); $i++) {
 if ($rs["arr"][$i]["name"] == $new_filename) {
 $filename_found = false;
 break;
 }
 }

 
 while (!$filename_found && $number < 20000) {
 $filename_found = true;
 
 $number++;
 $new_filename = $filename."_".$number.$extension;
 
 for ($i = 0; $i < sizeof($rs["arr"]); $i++) {
 if ($rs["arr"][$i]["name"] == $new_filename) {
 $filename_found = false;
 break;
 }
 }
 };

 return $new_filename;
}





function file_is_unique_db_column_ci($rows, $field) {
 global $FEATURE;

 $unique_column = array_unique(array_map(cb_cutright('mb_strtolower', 'UTF-8'),
 array_column($rows, $field)));
 if (count($rows) == count($unique_column)) {
 
 return true;
 } else if ($FEATURE["multichannelling"]) {
 
 
 $map = array();
 foreach ($rows as $row) {
 $map[$row[$field]."|".$row["channelset_id"]] = $row[$field];
 }

 $values = array_values($map);
 return count($values) == count(array_unique($values));
 } else {
 return false;
 }
}

?>
